<?php
/*
This File Upgrade Simpel Portal Classic Databse to the newest Version
(Can upgrade since Version 2.0.0)
*/

if (file_exists(dirname(__FILE__) . '/SSI.php') && !defined('SMF')) {
  require_once(dirname(__FILE__) . '/SSI.php');
	//Admin Check ;D
	global $user_info, $boardurl, $txt;
	if(!$user_info['is_admin']) {
		//Show a nice login, so that he can try to install it again ;)
		if($user_info['is_guest']) {
			echo '<b>', $txt[114],':</b><br />';
			ssi_login($boardurl.'/install.php');
			die();
		}
		else {
			loadLanguage('Errors');
			fatal_error($txt['cannot_admin_forum']);
		}
	}
}
// Hmm... no SSI.php and no SMF?
elseif (!defined('SMF'))
  die('<b>Error:</b> Cannot install - please verify you put this in the same place as SMF\'s index.php.');

/*
This Change work even if it changed, it should not create an error because nothing will happen if it allready done.
2.0.0 -> 2.0.3
*/
db_query("ALTER TABLE {$db_prefix}sp_articles CHANGE ID_ARTICLE 
	ID_ARTICLE INT( 10 ) NOT NULL AUTO_INCREMENT", __FILE__, __LINE__);

db_query("ALTER TABLE {$db_prefix}sp_articles CHANGE ID_CATEGORY 
	ID_CATEGORY INT( 10 ) DEFAULT 0 NOT NULL", __FILE__, __LINE__);

db_query("ALTER TABLE {$db_prefix}sp_articles CHANGE ID_MESSAGE 
	ID_MESSAGE INT( 10 ) DEFAULT 0 NOT NULL", __FILE__, __LINE__);

/*This is the array for alter Tables... i use this as my advance installer so i can made some changes quicker *g*
	Table without db_prefix
		array('table', 'rowname', 'rowsetting', 'update value');
	
	This Check if the row exists, if not than create it :), easy for update handling ;)
*/

$sql_adds = array(
	//2.0.3 -> 2.0.4
	array("sp_blocks", "allowed_groups", "text not null"),
	array("sp_blocks", "force_view", "TINYINT(2) unsigned DEFAULT '0' NOT NULL"),
	//2.0.4 -> 2.0.5
	array("sp_blocks", "permission_type", "TINYINT(2) unsigned DEFAULT '0' NOT NULL"),
);

foreach($sql_adds as $rowinfo) {
	
	$table = $rowinfo['0'];
	$rowname = $rowinfo['1'];
	$rowsetting = $rowinfo['2'];	

	//Mistake made... hmmm what should i do? XD Tell him that something not correct!
	if(empty($rowname) || empty($rowsetting)) {
		echo "SQL SMF INSTALLER: Error... rowname or rowsetting not set!";
		die();
	}
	
	//Load the rows ;)
	$request = db_query("SHOW COLUMNS FROM {$db_prefix}{$table}", __FILE__, __LINE__);
	
	$installed = false;
	
	while($row = mysql_fetch_assoc($request) ) {
		$installed = $row['Field'] == $rowname;
		if($installed)
			break;
	}
	
	mysql_free_result($request);
	
	//Not Installed Intall it ;)
	if(!$installed) {
		db_query("ALTER TABLE {$db_prefix}{$table} ADD $rowname $rowsetting", __FILE__, __LINE__);
		
		//I need to change values? Because it's new installed :)
		if(isset($rowinfo['3'])) {
			db_query("
				UPDATE {$db_prefix}{$table}
				SET $rowname = $rowinfo[3]", __FILE__, __LINE__);
		}
	}
}

//This is an special update, for older Versions than 2.0.4
$request = db_query("
	SELECT ID_GROUP, minPosts
	FROM {$db_prefix}membergroups", __FILE__, __LINE__);
$member_groups = array('posts' => array(), 'standard' => array());
while ($row = mysql_fetch_assoc($request)) {
	$member_groups[$row['minPosts'] == '-1' ? 'posts' : 'standard'][] = $row['ID_GROUP'];
}
mysql_free_result($request);

$member_groups['standard'][] = 0;
$member_groups['standard'][] = -1;

$allowed_groups_standard = implode(',', $member_groups['standard']);
$allowed_groups_new = $allowed_groups_standard . implode(',', $member_groups['posts']);

//This is an Special update ;D
db_query("
	UPDATE {$db_prefix}sp_blocks
	SET allowed_groups = '$allowed_groups_new', permission_type = 2
	WHERE allowed_groups = '$allowed_groups_standard'
		OR allowed_groups = ''", __FILE__, __LINE__);

// Put in the current SP version.
updateSettings(array('SimplePortal_version' => '2.0.5', 'SimplePortal_last_smf_version' => '1.1'));

//	Show a confirmation message, if an upgrade through SSI.php was successful.
if(SMF == 'SSI')
   echo 'Database Upgrade Complete!';
?>