<?php

if (!defined('SMF'))
	die('Hacking attempt...');

/*
File: Subs-SPortal1-1.php
Version: Simple Portal Classic 2.0.5 for SMF 1.1

getBlockInfo()
getFunctionInfo()
getCategoryInfo()
getArticleInfo()
createArticle()
fixCategoryArticles()
fixColumnRows()
changeBlockRow()
changeState()
sp_loadPermissions()
spAllowedTo()
sp_loadMemberGroups()
loadDatabaseTables()
databaseTableExists()

*/

function getBlockInfo($column_id = null, $block_id = null, $state = null)
{
	global $scripturl, $context, $db_prefix, $settings, $txt;

	$query = array();
	if(!empty($column_id))
		$query[] = "col = '$column_id'";
	if(!empty($block_id))
		$query[] = "ID_BLOCK = '$block_id'";
	if(!empty($state))
		$query[] = "state = '1'";
		
	$request = db_query("
		SELECT ID_BLOCK, label, type, content, parameters, col, row, state, force_view, allowed_groups, permission_type
		FROM {$db_prefix}sp_blocks" .
		(!empty($query) ? " WHERE " . implode(' AND ', $query) : "") .
		" ORDER BY row", __FILE__, __LINE__);
	$return = array();
	while ($row = mysql_fetch_assoc($request))
	{

		if(!spAllowedTo('block', $row['ID_BLOCK']))
			continue;

		$return[] = array(
			'id' => $row['ID_BLOCK'],
			'label' => $row['label'],
			'type' => $row['type'],
			'type_text' => !empty($txt['sp_function_'.$row['type'].'_label']) ? $txt['sp_function_'.$row['type'].'_label'] : $txt['sp_function_unkown_label'],
			'content' => $row['content'],
			'parameters' => $row['parameters'],
			'column' => $row['col'],
			'row' => $row['row'],
			'state' => empty($row['state']) ? 0 : 1,
			'force_view' => $row['force_view'],
			'allowed_groups' => $row['allowed_groups'],
			'permission_type' => $row['permission_type'],
		);
	}
	mysql_free_result($request);

	return $return;
}

function getFunctionInfo($function = null)
{
	global $db_prefix;

	$request = db_query("
		SELECT ID_FUNCTION, name, parameter
		FROM {$db_prefix}sp_functions" .
		(!empty($function) ? " WHERE name = '$function'" : "") .
		" ORDER BY ID_FUNCTION ASC", __FILE__, __LINE__);
	$return = array();
	while ($row = mysql_fetch_assoc($request))
	{

		$return[] = array(
			'id' => $row['ID_FUNCTION'],
			'function' => $row['name'],
			'parameter' => $row['parameter'],
		);
	}
	mysql_free_result($request);

	return $return;
}

function getCategoryInfo($category_id = null)
{
	global $scripturl, $context, $db_prefix, $settings, $txt;

	$request = db_query("
		SELECT ID_CATEGORY, name, picture, articles, publish
		FROM {$db_prefix}sp_categories" .
		(!empty($category_id) ? " WHERE ID_CATEGORY = '$category_id'" : "") .
		" ORDER BY ID_CATEGORY", __FILE__, __LINE__);
	$return = array();
	while ($row = mysql_fetch_assoc($request))
	{

		$return[] = array(
			'id' => $row['ID_CATEGORY'],
			'name' => $row['name'],
			'picture' => array (
				'href' => $row['picture'],
				'image' => '<img src="' . $row['picture'] . '" alt="' . $row['name'] . '" width="75" />',
			),
			'articles' => $row['articles'],
			'publish' => $row['publish'],
			'edit' => '<a href="' . $scripturl . '?action=spadmin;sa=categoryedit;id=' . $row['ID_CATEGORY'] . ';sesc=' . $context['session_id'] . '"><img src="' . $settings['default_theme_url'] . '/images/buttons/modify.gif" alt="'.$txt[17].'" title="'.$txt[17].'" /></a>',
			'delete' => '<a href="' . $scripturl . '?action=spadmin;sa=categorydelete;id=' . $row['ID_CATEGORY'] . ';sesc=' . $context['session_id'] . '"' . (empty($row['articles']) ? ' onclick="return confirm(\'' . $txt['sp-categoriesDeleteConfirm'] . '\');"' : ''). '><img src="' . $settings['default_theme_url'] . '/images/buttons/delete.gif" alt="'.$txt['smf138'].'" title="'.$txt['smf138'].'" /></a>'
		);
	}
	mysql_free_result($request);

	return $return;
}

function getArticleInfo($article_id = null, $category_id = null, $message_id = null, $approved = null)
{
	global $db_prefix;

	$query = array();
	if(!empty($article_id))
		$query[] = "ID_ARTICLE = '$article_id'";
	if(!empty($category_id))
		$query[] = "ID_CATEGORY = '$category_id'";
	if(!empty($message_id))
		$query[] = "ID_MESSAGE = '$message_id'";
	if(!empty($approved))
		$query[] = "approved = '1'";

	$request = db_query("
		SELECT a.ID_ARTICLE, a.ID_CATEGORY, a.ID_MESSAGE, a.approved, c.name
		FROM {$db_prefix}sp_articles as a
			LEFT JOIN {$db_prefix}sp_categories AS c ON (c.ID_CATEGORY = a.ID_CATEGORY)" .
		(!empty($query) ? " WHERE " . implode(' AND ', $query) : "") .
		" ORDER BY ID_ARTICLE", __FILE__, __LINE__);
	$return = array();
	while ($row = mysql_fetch_assoc($request))
	{

		$return[] = array(
			'article' => array(
				'id' => $row['ID_ARTICLE'],
				'approved' => $row['approved'],
			),
			'category' => array(
				'id' => $row['ID_CATEGORY'],
				'name' => $row['name'],
			),
			'message' => array(
				'id' => $row['ID_MESSAGE'],
			),
		);
	}
	mysql_free_result($request);

	return $return;
}

function createArticle($articleOptions)
{
	global $db_prefix;

	$articleOptions['ID_CATEGORY'] = !empty($articleOptions['ID_CATEGORY']) ? (int) $articleOptions['ID_CATEGORY'] : 0;
	$articleOptions['ID_MESSAGE'] = !empty($articleOptions['ID_MESSAGE']) ? (int) $articleOptions['ID_MESSAGE'] : 0;
	$articleOptions['approved'] = !empty($articleOptions['approved']) ? (int) $articleOptions['approved'] : 0;
		
	$request = db_query("
		SELECT ID_MESSAGE
		FROM {$db_prefix}sp_articles
		WHERE ID_MESSAGE = '$articleOptions[ID_MESSAGE]'
		LIMIT 1", __FILE__, __LINE__);
	list ($exists) = mysql_fetch_row($request);
	mysql_free_result($request);		

	if(empty($articleOptions['ID_CATEGORY']) || empty($articleOptions['ID_MESSAGE']) || $exists)
		return false;
		
	db_query("
		INSERT INTO {$db_prefix}sp_articles
			(ID_CATEGORY, ID_MESSAGE, approved)
		VALUES ('$articleOptions[ID_CATEGORY]', '$articleOptions[ID_MESSAGE]', $articleOptions[approved])", __FILE__, __LINE__);

	db_query("
		UPDATE {$db_prefix}sp_categories
		SET articles = articles + 1
		WHERE ID_CATEGORY = $articleOptions[ID_CATEGORY]
		LIMIT 1", __FILE__, __LINE__);
}

function fixCategoryArticles()
{
	global $db_prefix;

	$categoryList = getCategoryInfo();
	$categoryIds = array();	

	foreach($categoryList as $category)
		$categoryIds[] = $category['id'];

	foreach($categoryIds as $category) {

		$article_count = 0;
	
		$result = db_query("
			SELECT COUNT(*)
			FROM {$db_prefix}sp_articles
			WHERE ID_CATEGORY = $category", __FILE__, __LINE__);
		list ($article_count) = mysql_fetch_row($result);
		mysql_free_result($result);

		db_query("
			UPDATE {$db_prefix}sp_categories
			SET articles = $article_count
			WHERE ID_CATEGORY = $category
			LIMIT 1", __FILE__, __LINE__);
	}
}

function fixColumnRows($column_id = null)
{
	global $db_prefix;

	$blockList = getBlockInfo($column_id);
	$blockIds = array();	

	foreach($blockList as $block)
		$blockIds[] = $block['id'];

	$counter = 0;

	foreach($blockIds as $block) {

		$counter = $counter + 1;
	
		db_query("
			UPDATE {$db_prefix}sp_blocks
			SET row = $counter
			WHERE ID_BLOCK = $block
			LIMIT 1", __FILE__, __LINE__);
	}
}

function changeBlockRow($block_id = null, $direction = null)
{
	global $db_prefix;

	$blockInfo = getBlockInfo(null, $block_id);
	$blockInfo = $blockInfo[0];

	db_query("
		UPDATE {$db_prefix}sp_blocks
		SET row = $blockInfo[row]
		WHERE row = $blockInfo[row] " . ($direction == 'up' ? "-" : "+") . " 1
			AND col = $blockInfo[column]
		LIMIT 1", __FILE__, __LINE__);

	db_query("
		UPDATE {$db_prefix}sp_blocks
		SET row = row " . ($direction == 'up' ? "-" : "+") . " 1
		WHERE ID_BLOCK = $block_id
			AND col = $blockInfo[column]
		LIMIT 1", __FILE__, __LINE__);
}

function changeState($type = null, $id = null)
{
	global $db_prefix;

	if($type == 'block')
		$query = array(
			'column' => 'state',
			'table' => 'blocks',
			'id' => 'ID_BLOCK'
		);
	elseif($type == 'category')
		$query = array(
			'column' => 'publish',
			'table' => 'categories',
			'id' => 'ID_CATEGORY'
		);
	elseif($type == 'article')
		$query = array(
			'column' => 'approved',
			'table' => 'articles',
			'id' => 'ID_ARTICLE'
		);
	else
		return false;
	
	$request = db_query("
		SELECT $query[column]
		FROM {$db_prefix}sp_$query[table]
		WHERE $query[id] = $id
		LIMIT 1", __FILE__, __LINE__);
	list ($state) = mysql_fetch_row($request);
	mysql_free_result($request);

	$state = (int) $state;
	$state = ($state == 1) ? 0 : 1 ;

	db_query("
		UPDATE {$db_prefix}sp_$query[table]
		SET $query[column] = $state
		WHERE $query[id] = $id
		LIMIT 1", __FILE__, __LINE__);
}

// Make the allowed check faster, because i can cache this data!
// force_view is used for the way to make 3 diffrent ways to check blocks!
function sp_loadPermissions($type = null) {
	global $db_prefix, $sp_context, $user_info;
	
	//Checkup
	if(empty($type) || !in_array($type, array('block', 'article'))) 
		return false;

	//Prevent double load :)	
	if(!isset($sp_context['permissions'][$type]))
		$sp_context['permissions'][$type] = array();
	else
		return !empty($sp_context['permissions'][$type]); //On false allowed to nothing ;P
	
	//Blockquery Informations :)
	if($type == 'block') {
		//	Get the necessary block information.
		$request = db_query("
			SELECT allowed_groups AS allowed_groups, id_block AS id, permission_type
			FROM {$db_prefix}sp_blocks
			WHERE (permission_type = 2 
			OR (FIND_IN_SET(" . implode(', allowed_groups) OR FIND_IN_SET(', $user_info['groups']) . ", allowed_groups)))", __FILE__, __LINE__);
	}
	else {
		//	Get the necessary block information.
		$request = db_query("
			SELECT allowed_groups AS allowed_groups, id_article AS id
			FROM {$db_prefix}sp_articles
			WHERE (FIND_IN_SET(" . implode(', allowed_groups) OR FIND_IN_SET(', $user_info['groups']) . ", allowed_groups))", __FILE__, __LINE__);
	}

	//The output will only show the allowed positions ;D
	while($row = mysql_fetch_assoc($request)) {
		//This Permission need a extra checkup 8), it's a faster query now, a lot faster!
		if(!empty($row['permission_type']) && $row['permission_type'] == 1) {
			if(count(array_intersect($user_info['groups'], explode(',', $row['allowed_groups']))) != count($user_info['groups']))
				continue;
		}
		$sp_context['permissions'][$type][$row['id']] = $row['id'];
	}
	mysql_free_result($request);
	
	//Okay chached it ;) now it should be faster... a lot faster 8)
	return !empty($sp_context['permissions'][$type]);
}

//	Function to check if users are allowed to view certain blocks.
function spAllowedTo($type = null, $id = null)
{
	global $sp_context;
	// SP moderators are supermen. :D i need to do nothing if this correct! It's to late checked!
	// And this is the reason why admin unselect never work!
	// If we like to fix this we need to think about a way to allowed it in a other way or insert a force admin check
	if(allowedTo('sp_moderate'))
		return true;
	//	Sanitize the ID.
	$id = (int) $id;
	// Make sure that we have a proper id, load Permissions and store a chache 
	if(empty($id) || sp_loadPermissions($type) === false || empty($type))
		return false;
	//Pah if it isset than you allowed, if not than not :)
	return isset($sp_context['permissions'][$type][$id]);
}

/*
	void sp_loadMemberGroups(Array $selectedGroups = array, Array $removeGroups = array(), string $show = 'normal', string $contextName = 'member_groups')
	This will file the $context['member_groups'] to the given options
	$selectedGroups means all groups who should be shown as selcted, if you like to check all than insert an 'all'
		You can also Give the function a string with '2,3,4'
	$removeGroups this group id should not shown in the list
	$show have follow options
		'normal' => will show all groups, and add a guest and regular member (Standard)
		'post' => will load only post groups
		'master' => will load only not postbased groups
	$contextName where the datas should stored in the $context;

	The Administrator group id 1 will evertime ignored!
*/
function sp_loadMemberGroups($selectedGroups = array(), $show = 'normal', $contextName = 'member_groups')  {
	global $db_prefix, $context, $smcFunc, $txt;
	
	//Some additional Language stings are needed
	loadLanguage('ManageBoards');

	// Make sure its empty
	$context[$contextName] = array();
	
	//Preseting some things :)
	if(!is_array($selectedGroups))
		$checked = strtolower($selectedGroups) == 'all';
	else
		$checked = false;
	
	if(!$checked && !empty($selectedGroups)) {
		if(!is_array($selectedGroups)) 
			$selectedGroups = explode(',', $selectedGroups);
		//Remove all strings, i will only allowe ids :P
		foreach($selectedGroups as $k => $i)
			$selectedGroups[$k] = (int) $i;
		$selectedGroups = array_unique($selectedGroups);
	}
	else
		$selectedGroups = array();

	//Okay let's checkup the show function
	$show_option = array(
		'normal' => 'ID_GROUP != 1',
		'post' => 'minPosts != -1',
		'master' => 'minPosts = -1 AND ID_GROUP != 1',
	);
	$show = strtolower($show);
	if(!isset($show_option[$show]))
		$show = 'normal';

	// Guest and Members are added manually. Only on normal ond master View =)
	if($show == 'normal' || $show == 'master') {
		$context[$contextName][-1] = array(
			'id' => -1,
			'name' => $txt['membergroups_guests'],
			'checked' => $checked || in_array(-1, $selectedGroups),
			'is_post_group' => false,
		);
		$context[$contextName][0] = array(
			'id' => 0,
			'name' => $txt['membergroups_members'],
			'checked' => $checked || in_array(0, $selectedGroups),
			'is_post_group' => false,
		);
	}
	
	// Load membergroups.
	$request = db_query("
		SELECT groupName, ID_GROUP, minPosts
		FROM {$db_prefix}membergroups
		WHERE ".$show_option[$show]."
		ORDER BY minPosts, ID_GROUP != 2, groupName",__FILE__, __LINE__);
	while ($row = mysql_fetch_assoc($request))
	{
		$context[$contextName][(int) $row['ID_GROUP']] = array(
			'id' => $row['ID_GROUP'],
			'name' => trim($row['groupName']),
			'checked' => $checked || in_array($row['ID_GROUP'], $selectedGroups),
			'is_post_group' => $row['minPosts'] != -1,
		);
	}
	mysql_free_result($request);
}
/*
	bool loadDatabaseTables ()
	- Preload database Tables this will be only done once per script call
	- Return false on error
	- Mysql 3.x+ Compatible ;) for SMF 1.1.x
*/
function loadDatabaseTables() {
	global $database_tables, $db_name;
	
	if(isset($database_tables))
		return !empty($database_tables);
	else
		$database_tables = array();
			
	//Prepare a Checkup ;D
	$request = db_query("SHOW TABLES FROM `{$db_name}`", __FILE__, __LINE__);
	while ($row = mysql_fetch_assoc($request))
		$database_tables[] = strtolower(current($row));
	mysql_free_result($request);
	return !empty($database_tables);
}

/*
	bool databaseTableExists (string tablename, bool $addprefix = true)
	- Work only in SMF 1.1.x (SMF 2.0.x work diffrent, but it's possible to insert)
	- Return true if the tablename exits
	- $addprefix will automatic add the $db_prefix (Check also it this is allready done!)
*/
function databaseTableExists($tablename = '', $addprefix = true) {
	global $database_tables, $db_prefix;
	
	//Nothing to Serach for ;)
	if(empty($tablename))
		return false;

	//Error ?_?
	if(empty($database_tables) && !loadDatabaseTables())
		return false;
	
	//First thing i do.. i know normal i should not so this ;P But it's good enouph for smf ;)
	$tablename = strtolower($tablename);
	
	//Table Prefix auto add? :D
	if($addprefix === true && strpos($tablename, $db_prefix) !== 0) {
		//Looks not so nice ;) but it work trust me ;P
		if(strpos($tablename, '{$db_prefix}') !== false)
			$tablename = str_replace('{$db_prefix}', $db_prefix, $tablename);
		elseif(strpos($tablename, '$db_prefix') !== false)
			$tablename = str_replace('$db_prefix', $db_prefix, $tablename);
		else
			$tablename = $db_prefix.$tablename;
	}
	return in_array($tablename, $database_tables);
}

?>